sampler sampler0_ : register( s0 );

struct PS_INPUT
{
	float4 diffuse	: COLOR0;
	float2 texCoord	: TEXCOORD0;
	float2 vPos	: VPOS;
};

struct PS_OUTPUT
{
	float4 color	: COLOR0;
};

float width = 1;
float rand = 0;

float tex_width = 1024;

float random(in float2 uv)
{
    float2 noise = (frac(sin(dot(uv ,float2(12.9898,78.233)*2.0)) * 43758.5453));
    return abs(noise.x + noise.y) * 0.5-0.5;
}

PS_OUTPUT PS( PS_INPUT In ) : COLOR0
{
	PS_OUTPUT Out;

	float2 uv;
		uv.x = In.texCoord.x;
		uv.y = In.texCoord.y;

	uv.x += width*random(uv.y+rand)/tex_width;

	float4 colorTexture = tex2D(sampler0_, uv);
	float4 colorDiffuse = In.diffuse;
	float4 color = colorTexture * colorDiffuse;

	Out.color = color;

	return Out;
}

technique Render
{
	pass P0
	{
		PixelShader = compile ps_3_0 PS();
	}
}

